Open Lighting Architecture: ola::plugin::usbdmx::SynchronousDMXCProjectsNodleU1 Class Reference

| Open Lighting Architecture 0.10.9

Loading...
Searching...
No Matches
Public Member Functions | List of all members
ola::plugin::usbdmx::SynchronousDMXCProjectsNodleU1 Class Reference

## Detailed Description

An Nodle widget that uses synchronous libusb operations.

Internally this spawns a new thread to avoid blocking SendDMX() calls.

Inheritance diagram for ola::plugin::usbdmx::SynchronousDMXCProjectsNodleU1:

## Public Member Functions
| SynchronousDMXCProjectsNodleU1 (ola::usb::LibUsbAdaptor *adaptor, libusb_device *usb_device, PluginAdaptor *plugin_adaptor, const std::string &serial, unsigned int mode)
| Create a new SynchronousDMXCProjectsNodleU1.
bool | Init ()
| Initialize the widget.
bool | SendDMX (const DmxBuffer &buffer)
| Send DMX data from this widget.
void | SetDmxCallback (Callback0< void > *callback)
const DmxBuffer & | GetDmxInBuffer ()
Public Member Functions inherited from ola::plugin::usbdmx::DMXCProjectsNodleU1
| DMXCProjectsNodleU1 (ola::usb::LibUsbAdaptor *adaptor, libusb_device *usb_device, PluginAdaptor *plugin_adaptor, const std::string &serial, unsigned int mode)
std::string | SerialNumber () const
| Get the serial number of this widget.
unsigned int | Mode () const
| Get the current mode of this widget.
Public Member Functions inherited from ola::plugin::usbdmx::SimpleWidget
| SimpleWidget (ola::usb::LibUsbAdaptor *adaptor, libusb_device *usb_device)
| Create a new SimpleWidget.
ola::usb::USBDeviceID | GetDeviceId () const
| The device ID of this widget.

## Additional Inherited Members
Static Public Attributes inherited from ola::plugin::usbdmx::DMXCProjectsNodleU1
static int | NODLE_DEFAULT_MODE = 6
static int | NODLE_MIN_MODE = 0
static int | NODLE_MAX_MODE = 7
static int | OUTPUT_ENABLE_MASK = 2
static int | INPUT_ENABLE_MASK = 4
Protected Attributes inherited from ola::plugin::usbdmx::DMXCProjectsNodleU1
unsigned int | m_mode
PluginAdaptor * | m_plugin_adaptor
Protected Attributes inherited from ola::plugin::usbdmx::SimpleWidget
ola::usb::LibUsbAdaptor *const | m_adaptor
libusb_device *const | m_usb_device

## Constructor & Destructor Documentation

## ◆ SynchronousDMXCProjectsNodleU1()

ola::plugin::usbdmx::SynchronousDMXCProjectsNodleU1::SynchronousDMXCProjectsNodleU1 | ( | ola::usb::LibUsbAdaptor * | adaptor,
|  | libusb_device * | usb_device,
|  | PluginAdaptor * | plugin_adaptor,
|  | const std::string & | serial,
|  | unsigned int | mode )

Create a new SynchronousDMXCProjectsNodleU1.

Parameters

  adaptor | the LibUsbAdaptor to use.
  usb_device | the libusb_device to use for the widget.
  plugin_adaptor | the PluginAdaptor used to execute callbacks
  serial | the serial number of this widget
  mode | the send/receive mode to be used by the widget.

## Member Function Documentation

## ◆ GetDmxInBuffer()

const DmxBuffer & ola::plugin::usbdmx::SynchronousDMXCProjectsNodleU1::GetDmxInBuffer | ( |  | ) |
| virtual

Implements ola::plugin::usbdmx::DMXCProjectsNodleU1.

## ◆ Init()

bool ola::plugin::usbdmx::SynchronousDMXCProjectsNodleU1::Init | ( |  | ) |
| virtual

Initialize the widget.

Returns
  true if this widget was initialized correctly, false otherwise.

Implements ola::plugin::usbdmx::WidgetInterface.

## ◆ SendDMX()

bool ola::plugin::usbdmx::SynchronousDMXCProjectsNodleU1::SendDMX | ( | const DmxBuffer & | buffer | ) |
| virtual

Send DMX data from this widget.

Parameters

  buffer | The DmxBuffer containing the data to send.

Returns
  true if the data was sent, false otherwise.

Implements ola::plugin::usbdmx::WidgetInterface.

## ◆ SetDmxCallback()

void ola::plugin::usbdmx::SynchronousDMXCProjectsNodleU1::SetDmxCallback | ( | Callback0< void > * | callback | ) |
| virtual

Implements ola::plugin::usbdmx::DMXCProjectsNodleU1.

The documentation for this class was generated from the following files:

- plugins/usbdmx/DMXCProjectsNodleU1.h
- plugins/usbdmx/DMXCProjectsNodleU1.cpp